#include <stddef.h>
#include <Stream.h>

#define LineReceiver_MaxLineLength 100

class LineReceiver
{
  private:
    Stream* stream = NULL;
    void (*callback)(String line) = NULL;
    String data = "";
  public:
    LineReceiver(Stream* stream, void (*callback)(String line));
    void clk();
};

LineReceiver::LineReceiver(Stream* stream, void (*callback)(String line)) {
  this->stream = stream;
  this->callback = callback;
}

void LineReceiver::clk() {
  while (stream->available())
  {
    char c = stream->read();
    if (c == '\n')
    {
      callback(data);
      data = "";
    }
    else
    {
      data += c;
      if (data.length() >= LineReceiver_MaxLineLength)
      {
        callback(data);
        data = "";
      }
    }
  }
}
