#include "Arduino.h"

#define Timer_GetTime() millis()

class Timer
{
  private:
    unsigned long last = 0;
    void (*callback)(void) = NULL;
    
  public:
    unsigned long interval = 0;
    bool enabled = false;

    Timer(unsigned long interval, bool enabled, void (*callback)(void));
    
    void reset();
    void clk();
};

Timer::Timer(unsigned long interval, bool enabled, void (*callback)(void))
{
  this->interval = interval;
  this->enabled = enabled;
  this->callback = callback;
}

void Timer::reset()
{
  last = Timer_GetTime();
}

void Timer::clk()
{
  if ((Timer_GetTime() - last) >= interval)
  {
    if (enabled)
      callback();
    last = Timer_GetTime();
  }
}
